    'PROGRAM Centriset
    'Copyright 2007  A.H.Eliason, L.J. Poppe

    nomainwin


    dim properties(10) 'use this to store global properties
    global Tt,Va,Pr,Pp,Po,Vi,Ta,Td,R1,R2
    global Pd,Pr,Fd,Ga,Fv,Vs
    'set up global window sizing values
    UpperLeftX = 10
    UpperLeftY = 10
    'WindowWidth = 550
    'WindowHeight = 400
    'WindowWidth = 1550
    'WindowHeight = 1000
    False=0
    True=NOT(False)
    Test=False

    'nomainwin
    'WindowWidth = DisplayWidth/2
    'WindowHeight = DisplayHeight/2
    WindowWidth = 750
    WindowHeight =550

    statictext #main.statictext1, "Centrifugation Settling Analysis (Solves for Total Time or Angular Velocity)", 52, 16, 680, 20
    textbox #main.Tt, 246, 76, 100, 25
    textbox #main.Va, 558, 76, 100, 25
    textbox #main.Pr, 246, 126, 100, 25
    textbox #main.Pp, 558, 126, 100, 25
    textbox #main.Po, 246, 176, 100, 25
    textbox #main.Vi, 558, 176, 100, 25
    textbox #main.Ta, 246, 226, 100, 25
    textbox #main.Td, 558, 226, 100, 25
    textbox #main.R1, 246, 276, 100, 25
    textbox #main.R2, 558, 276, 100, 25
    graphicbox #main.graph, 90, 400, 549, 72
    statictext #main.statictext12, "Total Time (sec)", 134, 81, 110, 20
    statictext #main.statictext13, "Angular Velocity (rev/sec)", 390, 81, 155, 20
    statictext #main.statictext14, "Particle Radius (cm)", 110, 131, 135, 20
    statictext #main.statictext15, "Particle Density (g/cm^3)", 398, 131, 155, 20
    statictext #main.statictext16, "Fluid Density (g/cm^3)", 102, 181, 135, 20
    statictext #main.statictext17, "Fluid Viscosity (poises)", 406, 181, 145, 20
    statictext #main.statictext18, "Time of Acceleration (sec)", 78, 231, 156, 20
    statictext #main.statictext19, "Time of Deceleration (sec)", 382, 231, 175, 20
    statictext #main.statictext20, "Initial Distance from Axis (cm)", 60, 281, 177, 20
    statictext #main.statictext21, "Final Distance from  Axis (cm)", 366, 281, 177, 20
    'statictext #main.statictext22, "Informaton", 60, 310, 125, 20
    button #main.button22, "Calculate", [button22Click], UL, 326, 331, 82, 25
    button #main.button23, "Stokes Law", [button23Click], UL, 200, 331, 98, 25
    button #main.button2, "Next ", [button2Click], UL, 435, 331, 42, 25
    button #main.button4, "Clear all", [button4Click], UL, 504, 331, 70, 25
    button #main.button5, "Exit", [button5Click], UL, 594, 331, 42, 25


    combobox #main.combobox3, Array$() , [selected], 35, 332, 124, 33
    Array$(0)="Water Properties"
    Array$(1)="Common Densities"
    Array$(2)="Grade Scale"
    Array$(3)="Axis Distance"
    Array$(4)="Stokes Law"
    Array$(5)="Centrifugation Equ."
    Array$(6)="Documentation"
    'Array$(6)="Equation Derivation"
    open "Centriset.exe" for window as #main
    print #main, "font ms_sans_serif 0 16"
    print #main.statictext1, "!font ms_sans_serif 0 20 bold"
    print #main.combobox3, "!Information"
    gosub [logo]
[main.inputLoop]   'wait here for input event
    wait

[selected]   'Perform action for the combobox named 'combobox3'
    'call openTextWindow
    print #main.combobox3, "selectionindex? xVar"     ' convert index to xVar
    'print #text, "Info Request =" + str$(xVar)        ' Print the index to info window  killed LJP 8/28

    UpperLeftX = 30
    UpperLeftY = 30
    SELECT CASE xVar
    CASE 0
    CASE 1
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 348
        WindowHeight =608
        loadbmp "copyimage", "water.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 10 10"
        print #graphic, "flush"

    CASE 2
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 593
        WindowHeight =550
        loadbmp "copyimage", "densities.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 10 10"
        print #graphic, "flush"
    CASE 3
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 770
        WindowHeight =770
        loadbmp "copyimage", "gscale.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 10 10"
        print #graphic, "flush"
    CASE 4
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 623
        WindowHeight =478
        loadbmp "copyimage", "axis_distance.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 10 10"
        print #graphic, "flush"

    Case 5
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 490
        WindowHeight =424
        loadbmp "copyimage", "stokeslaw.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 10 10"
        print #graphic, "flush"

    Case 6
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 490
        WindowHeight =484
        loadbmp "copyimage", "centrif_equation.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 10 10"
        print #graphic, "flush"

    Case 7
        call closeGraphWindow
        CALL openGraphWindow
        WindowWidth = 740
        WindowHeight =500
        loadbmp "copyimage", "CentrisetDoc.bmp"
        open "Information" for graphics as #graphic
        print #graphic, "drawbmp copyimage 50 10"
        print #graphic, "flush"



END SELECT
        UNLOADBMP "copyimage"
        print #main.combobox3, "reload"     ' Clear the combobox
        print #main.combobox3, "selectionindex? xVar"
        call Pause 1000
        print #main.combobox3, "!Information"
    wait




[button3Click]   'Perform action for the button named 'button3'
    'Insert your own code here
    wait

[button2Click]   'Perform action for the button named 'button2'
    print #main.Tt, ""         'Clear T & V input boxes to null
    print #main.Va, ""
    wait

[button4Click]   'Perform action for the button named 'Clear All'
    If NOT(Test) then
        print #main.Tt, ""         'Clear all input boxes to null
        print #main.Va, ""
        print #main.Pr, ""
        print #main.Pp, ""
        print #main.Po, ""
        print #main.Vi, ""
        print #main.Ta, ""
        print #main.Td, ""
        print #main.R1, ""
        print #main.R2, ""
     else
        print #main.Tt, ""         'Test mode fill with typical values
        print #main.Va, ""
        print #main.Pr, ".0001"
        print #main.Pp, "2.65"
        print #main.Po, ".998"
        print #main.Vi, ".01005"
        print #main.Ta, "30"
        print #main.Td, "30"
        print #main.R1, "10"
        print #main.R2, "17"
    End if

    call closeTextWindow        'Close the current text window, if any.
    call closeGraphWindow
    wait

[button22Click]   'Perform action for the button named 'Calculate

    print #main.Tt, "!contents? Tt"         'Convert all text to variables
    print #main.Va, "!contents? Va"
    print #main.Pr, "!contents? Pr"
    print #main.Pp, "!contents? Pp"
    print #main.Po, "!contents? Po"
    print #main.Vi, "!contents? Vi"
    print #main.Ta, "!contents? Ta"
    print #main.Td, "!contents? Td"
    print #main.R1, "!contents? R1"
    print #main.R2, "!contents? R2"
        WindowWidth = 600
        WindowHeight =500

    call openTextWindow
print #text, "============Report starts============="
    print #text, "Ver CENTRI 8/29         Date: ";date$();" Time: :";Time$()
        print #text, Tt; ","; Va
        print #text, Pr; ","; Pp; ","; Po; ","; Vi
        print #text, Ta; ","; Td; ","; R1; ","; R2
        err1=0
        if Tt=0 and Va=0 Then
        print #text, "Need value for Total Time or Angular Velocity": err1=1
        end if
        if Tt>0 and Va>0 Then
        print #text, "Need Zero value for Parameter to Compute.": err1=1
        end if
        If Pr=0 or Pp=0 or Po=0 or Vi=0 or Ta=0 or Td=0 or R1=0 or R2=0 Then
        print #text, "One or more required parameters unpopulated":err1=1
        end If
        If Pr > 1.0  or Pr< 0.000001 then print #text, "Particle Radius out of range.":err1=1
        If Pp > 10.0 or Pp < 0.1     then print #text, "Particle Density out of range.":err1=1
        If Po > 5.0  or Po < 0.1     then print #text, "Fluid Density out of range.":err1=1
        If Vi > 1.0  or Vi < 0.00001 then print #text, "Fluid Viscosity out of range.":err1=1
        If Ta > 180.0 or Ta < 5.0    then print #text, "Acceleration Time out of range.":err1=1
        If Td > 180.0 or Td < 5.0    then print #text, "Deceleration Time out of range.":err1=1
        If R1 > 70.0  or R1 < 5.0    then print #text, "Initial Distance out of range.":err1=1
        If R2 > 70.0  or R2 < 5.0    then print #text, "Final Distance out of range.":err1=1
        if Tt=0 and (Va >1500 or Va < 1)    then print #text, "Angular Velocity out of range.":err1=1
        if Va=0 and (Tt >15000 or Tt < 20)  then print #text, "Total Time out of range.":err1=1
        if err1=1 then playwave "ding.wav":goto [Quitsub]


        if Tt=0 Then       'Solve for Time


            pi = asn(1) * 2
            Nu1 = 9*Vi* log(R2/R1)
            Nu2 = 2*(Ta+Td)
            De1 = 8*pi^2*Va^2*Pr^2*(Pp-Po)

            Tt= Nu1/De1+ Nu2/3

            'print #text, "9Vi Log n(R2/R1) =";Nu1;"  2(ta+td) =";Nu2    'only print these if troubleshooting
            'print #text, "8pi^2 N^2 r^2 (p-po) =";De1;
            'print #text, Nu1;" / ";De1;" + ";Nu2;" / 3 = "; Tt
            print #text, "Total Time =" + using("#####.#",Tt)
            print #text, " "
            print #main.Tt, using("#####.#",Tt)

            if (Tt < (Ta + Td)) then
                print #text, "WARNING: Separation completed prior to expiration of total time!"
                playwave "ding.wav"
            else
                playwave "tada.wav"
            end if
        end if



        if Va = 0 Then          ' Solve for Angular Velocity
        'N = +/- sqrt( (9*h*Log(Rb/Ra) / ( T - 2*(ta+td)/3 )8*pi^2*r^2* (p-po) ).
        pi = asn(1) * 2
        Nu1= 9*Vi*Log(R2/R1)
        De1= (Tt-2*(Ta+Td)/3)
        De2= 8*pi^2*Pr^2*(Pp-Po)
        Va=Sqr(Nu1/(De1*De2))
        'print #text, "Va = Sqr(";Nu1;" /( ";De1;" x ";De2;") = ";Va      'only print this if troubleshooting
        print #text, "Angular Velocity (rev/sec) =" + using("####.#",Va)
        print #text, " "
        print #main.Va, using("####.#",Va)
        Tr=Tt               ' Test for realistic time input

        if (Tr < (Ta + Td)) Then
            print #text, "WARNING: Imposable time specification! T < Ta+Td"
                playwave "ding.wav"
            else
                playwave "tada.wav"
            end if
        end if

[Quitsub]



    wait
[button23Click]  'Perform action for the button named 'button23'
    'call openTextWindow
    'print #text, "Stokes Routine is under development. "
    'print #text, "Not available in this version. "
    gosub [Stokes]
    wait

[button5Click]   'Perform action for the button named 'button5'
    call openTextWindow
    print #text, "Shutting Down"
    close #main
    call Pause 1000     ' wait 1 second
    goto [quit]

    wait

[quit]          ' end program

    call closeGraphWindow
    call Pause 1000
    call closeTextWindow

    end

sub Pause mil
    t=time$("milliseconds")
    while time$("milliseconds")<t+mil
    wend
    end sub


sub openGraphWindow
    if isGraphOpen() = 0 then   'only open it if it isn't open

        'print #graph, "trapclose [closeGraph]"
        'print #graph, "down"
        call graphIsOpen
    else
        'I could do something here if the window is open
    end if

end sub

sub openTextWindow
    if isTextOpen() = 0 then   'only open it if it isn't open
        UpperLeftX = 10
        UpperLeftY = 500
        WindowHeight = 400
        open "Calculation Report" for text as #text
        print #text, "!trapclose [closeText]";
        call textIsOpen
    else
        'I could do something here if the window is open
    end if
end sub

[closeGraph]
    call closeGraphWindow
    wait

sub closeGraphWindow
    if isGraphOpen() then
        close #graphic
        call graphIsClosed
        xVar=0
    end if
end sub

[closeText]
    call closeTextWindow
    wait

sub closeTextWindow
    if isTextOpen() then
        close #text
        call textIsClosed
    end if
end sub

sub graphIsOpen    'indicate that the graph window is open
    properties(0) = 1
end sub

sub graphIsClosed    'indicate that the graph window is closed
    properties(0) = 0
end sub

sub textIsOpen    'indicate that the text window is open
    properties(1) = 1
end sub

sub textIsClosed    'indicate that the text window is closed
    properties(1) = 0
end sub

function isGraphOpen()    'is the graph window open? return zero or non-zero
    isGraphOpen = properties(0)
end function

function isTextOpen()    'is the text window open? return zero or non-zero
    isTextOpen = properties(1)
end function

[Stokes]
    WindowWidth = 750
    WindowHeight =400
    statictext #main2.statictext2, "Gravitational Settling Analysis", 100, 16, 348, 20
    statictext #main2.statictext3, "Particle Density  gm/cm^3", 22, 66, 200, 20
    textbox #main2.Pd, 302, 61, 104, 25
    statictext #main2.statictext6, "Particle Radius (cm)", 22, 101, 160, 20
    textbox #main2.Pr, 302, 101, 104, 25
    statictext #main2.statictext9, "Fluid Density (g/cm^3)", 22, 141, 176, 20
    textbox #main2.Fd, 302, 141, 104, 25
    statictext #main2.statictext11, "Gravitational Acceleration (cm/sec^2)", 22, 181, 280, 20
    textbox #main2.Ga, 302, 181, 104, 25
    statictext #main2.statictext13, "Fluid Viscosity (Poises)", 22, 226, 192, 20
    textbox #main2.Fv, 302, 221, 104, 25
    statictext #main2.statictext14, "Settling Velocity (cm/sec)    RESULT", 22, 271, 230, 20
    textbox #main2.Vs, 302, 271, 104, 25

    button #main2.button15, "Calculate", [button15Click], UL, 198, 331, 82, 25
    button #main2.button16, "Next ", [button16Click], UL, 308, 331, 82, 25
    button #main2.button17, "Close", [button17Click], UL, 418, 331, 82, 25
    'print #main2, "font ms_sans_serif 0 32"
    open "Stokes Law Solution" for window as #main2
    print #main2, "font ms_sans_serif 0 16"

    print #main2.statictext2, "!font ms_sans_serif 0 20 bold"
    print #main2, "trapclose [quit2]"

[main2.inputLoop]   'wait here for input event
    wait

[quit2]
    Close #main2
    call closeTextWindow

    return



[button15Click]   'Perform action for the button named 'Calculate'
    'Make sure that each parameter is populated


    'call openGraphWindow
    print #main2.Pd, "!contents? Pd"             'somehow this converts the text box to numeric variables
    print #main2.Pr, "!contents? Pr"
    print #main2.Fd, "!contents? Fd"
    print #main2.Ga, "!contents? Ga"
    print #main2.Fv, "!contents? Fv"

    call openTextWindow
    print #text, "============Report starts============="
    print #text, "Stokes Law Ver 08/29/2007"
        print #text, Pd; ","; Pr;","; Fd;","; Ga;","; Fv
        err1=0
    If Pd=0 or Pr=0 or Fd=0 or Ga=0 or Fv=0 Then
        print #text, "One or more required parameters unpopulated":err1=1
    end If
    if Pd > 10 or Pd < 0.1 then print #text, "Particle Density out of range.":err1=1
    If Pr > 99  or Pr< 0.000001 then print #text, "Particle Radius out of range.":err1=1
    If Fd > 5.0  or Fd < 0.000001 then print #text, "Fluid Density out of range.":err1=1
    If Ga > 1000  or Ga < 900 then print #text, "Gravitational Acceleration out of range.":err1=1
    If Fv > 1.0  or Fv< 0.000001 then print #text, "Fluid Viscosity out of range.":err1=1
    if err1=1 then playwave "ding.wav":goto [Quitsub]

    if err1=0 then
        playwave "tada.wav"
        n1=(Pr*Pr)*Ga
        n2=Pd-Fd
        d1 = Fv
        x1=(n1*n2)/d1
        Vs= (2/9)*x1
        'print #text, "r^2 g =";n1;"  p-po =";n2            'only print these if troubleshooting
        'print #text, "2/9 x";n1;" x ";n2;" / ";d1;" = ";Vs
        print #text, "Settling Velocity Vs =" + using("##.#########",Vs)
        print #main2.Vs, using ("##.#########",Vs)
    Else
        playwave "ding.wav"
    End if
    wait
end
[button16Click]   'Perform action for the button named 'Next'
    print #main2.Vs, ""
    Vs=0
    wait

[button17Click]   'Perform action for the button named 'Close'

    goto [quit2]
wait
[logo]
    LOADBMP "splash", "usgs_cape_549x72.bmp"
    'graphicbox #main.graph, 90, 400, 549, 72
    'GRAPHICBOX #1.gbx, 6, 10, 549, 72
    'BUTTON #1.btn, "CLOSE", [quit], UL, 80, 153, 40, 20
    'oPEN "My Picture Window" FOR window as #1
    'PRINT #1, "trapclose [quit]"
    PRINT #main.graph, "down"
    FOR y=255 to 0 step -1  'Begin with image off-screen, bottom.
        TIMER 10, [pause]
        WAIT
        [pause]
        TIMER 0
        PRINT #main.graph, "discard"
        'Tell the program "what" to print, and "where" to print.
        'The syntax is "PRINT #handle.ext, "drawbmp name x y"
        'In this example, we are changing the horizontal origin (y) with each 'pass through the loop.
        PRINT #main.graph, "drawbmp splash 0 "; y  'Reposition the image
    NEXT y
     print #main.graph, "flush"
return
[quit3]
    UNLOADBMP "splash"
    'CLOSE #main.graph
    END



